
from Globals import *
import gobject
import gtk
import gtk.glade

class NewGroupDialog(gobject.GObject):

    __gsignals__ = {
        'account-created' : (gobject.SIGNAL_RUN_LAST, gobject.TYPE_NONE,
                                (gobject.TYPE_PYOBJECT, ))
        }

    def __init__(self, container):
        gobject.GObject.__init__(self)
        self.container = container

        self.gxml = gtk.glade.XML(GLADE_FILE, 'newGroupDialog')
        self.dlg = self.gxml.get_widget('newGroupDialog')

        self.errorMessage = self.gxml.get_widget('errorMessage')

        # Connect the glade signals
        function_dict = dict([(f, getattr(self, f)) for f in dir(self)]) 
        self.gxml.signal_autoconnect(function_dict)

    def SetErrorMessage(self, message):
        errorTemplate = '<span color="red"><b>%s</b></span>'
        self.errorMessage.set_text(errorTemplate % (message))
        self.errorMessage.set_use_markup(True)
        self.errorMessage.show()

    def OnOkClicked(self, obj, *args):

        self.dlg.hide()

        groupName = self.gxml.get_widget('groupName').get_text()
        gidNumber = None
        try:
            self.container.CreateGroup(groupName, gidNumber)

            self.emit('account-created', self.container)
            self.dlg.destroy()        
        except Exception, err:
            self.SetErrorMessage(err)
            print err
            self.dlg.show()
            self.gxml.get_widget('groupName').grab_focus()

    def OnCancelClicked(self, obj, *args):
        self.dlg.destroy()

    def OnDeleteEvent(self, obj, *args):
        return False

gobject.type_register(NewGroupDialog)
